
#include "p4.h"

main(argc, argv)
int argc ;
char** argv ;
{
  p4_initenv(&argc, argv) ;
  p4_create_procgroup() ;
  worker() ;
  p4_wait_for_end() ;
}

worker() {
  int msg [1] = {23} ;
  char* incoming ;
  int myid, size, nprocs, from, i, type ;

  myid = p4_get_my_id() ;
  nprocs = p4_num_total_ids() ;
  for(i = 0 ; i < nprocs ; i++) {
    if(i != myid)
      p4_send(100, i, (char*) msg, 1 * sizeof(int)) ;
  }
  incoming = p4_msg_alloc(1 * sizeof(int)) ;
  for(i = 0 ; i < nprocs - 1 ; i++) {
    type = -1 ;
    from = -1 ;
    p4_recv(&type, &from, &incoming, &size) ;
    printf("%d received msg=:%d: from %d\n", myid, ((int*) incoming) [0],
	   from) ;
  }
  p4_msg_free(incoming) ;
}


/* 
worker() {
  char *incoming, *msg = "hello" ;
  int myid, size, nprocs, from, i, type ;

  myid = p4_get_my_id() ;
  nprocs = p4_num_total_ids() ;
  for(i = 0 ; i < nprocs ; i++) {
    if(i != myid)
      p4_send(100, i, msg, strlen(msg) + 1) ;
  }
  for(i = 0 ; i < nprocs - 1 ; i++) {
    type = -1 ;
    from = -1 ;
    incoming = NULL ;
    p4_recv(&type, &from, &incoming, &size) ;
    printf("%d received msg=:%s: from %d\n", myid, incoming, from) ;
    p4_msg_free(incoming) ;
  }
}
*/

